//=========================================================================
//
//	FILE:				CP_POP3Response.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Base class to handle responses from our POP3 servers.
//
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_POP3Response
#define _H_CP_POP3Response
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_InternetResponse.h"
#include "CP_NetProtoBase.h"
#include "CP_Socket.h"
#include "CP_String.h"
#include "CP_Types.h"

CPLAT_Begin_Namespace_CPLAT

#define kCP_POP3_StatusOKIndicator					"+OK"
#define kCP_POP3_StatusErrorIndicator					"-ERR"

/*!
*	@class		CP_POP3Response
*	@brief		A CP_InternetResponse class to handle POP3 server responses. This class is designed
*				to be used with the CP_POP3 class.
*/
class CP_EXPORT CP_POP3Response : public CP_InternetResponse
{
public:
	enum
	{
		kCP_POP3__ServerResponseOK		= CP_FOUR_CHAR_CODE('+OK '),
		kCP_POP3__ServerResponseError	= CP_FOUR_CHAR_CODE('-ERR')
	};
	
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_POP3Response( CP_Socket *inSocket );
										CP_POP3Response( const CP_POP3Response& inResponse );
	//! Destructor.
	virtual								~CP_POP3Response() throw();
	//@}
				
	//! @name Server response
	//@{
	virtual	bool						GetServerResponse();

			bool						GetMultiLineResponse( CP_InternetProtocolProgress& inProtocolProgress );
	//@}
	
protected:
	
private:

	// class data
protected:

//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_POP3Response


