//=========================================================================
//
//	FILE:				CP_UIFieldGetters.h
//	
//						Copyright  2005. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Routines used to set data into various CPLAT UI views.
//	
//	HISTORY:			1st Version - April 2005.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev:$
//						Latest Checkout:  $Date:$
//
//=========================================================================
#ifndef _H_CP_UIFieldGetters
#define _H_CP_UIFieldGetters
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_EditField.h"
#include "CP_SelectColorButton.h"

CPLAT_Begin_Namespace_CPLAT

namespace CP_UIFieldGetters
{
		// CP_EditField
	SInt16 							CP_EditFieldToSInt16( CP_EditField *inEditField );
	SInt32							CP_EditFieldToSInt32( CP_EditField *inEditField );
	float							CP_EditFieldToFloat( CP_EditField *inEditField );
	CP_String						CP_EditFieldToString( CP_EditField *inEditField );

	SInt16							CP_EditFieldToSInt16(
											CP_View *inSuperview,
											UInt32 inObjectID,
											bool inRecrusive = kCP_NoRecrusiveSearch );
	SInt32							CP_EditFieldToSInt32(
											CP_View *inSuperview,
											UInt32 inObjectID,
											bool inRecrusive = kCP_NoRecrusiveSearch );
	UInt32							CP_EditFieldToUInt32(
											CP_View *inSuperview,
											UInt32 inObjectID,
											bool inRecrusive = kCP_NoRecrusiveSearch );
	float							CP_EditFieldToFloat(
											CP_View *inSuperview,
											UInt32 inObjectID,
											bool inRecrusive = kCP_NoRecrusiveSearch );
	CP_String						CP_EditFieldToString(
											CP_View *inSuperview,
											UInt32 inObjectID,
											bool inRecrusive = kCP_NoRecrusiveSearch );

	
		// CP_PlatformControl
	bool							CP_PlatformControlToBool( CP_PlatformControl *inPlatformControl );
	bool							CP_PlatformControlToBool(
											CP_View *inSuperview,
											UInt32 inObjectID,
											bool inRecrusive = kCP_NoRecrusiveSearch );

		// CP_PopupMenu
	SInt32							CP_PopupMenuToSInt32( CP_PopupMenu *inPopupMenu );
	SInt32							CP_PopupMenuToSInt32(
											CP_View *inSuperview,
											UInt32 inObjectID,
											bool inRecrusive = kCP_NoRecrusiveSearch );

		// CP_SelectColorButton
	CP_RGBColor						CP_SelectColorButtonToCP_RGBColor( CP_SelectColorButton *inSelectColorButton );
	CP_RGBColor						CP_SelectColorButtonToCP_RGBColor(
											CP_View *inSuperview,
											UInt32 inObjectID,
											bool inRecrusive = kCP_NoRecrusiveSearch );

		// CP_TextView
	CP_String						CP_TextViewToString( CP_TextView *inTextView );

	CP_String						CP_TextViewToString(
											CP_View *inSuperview,
											UInt32 inObjectID,
											bool inRecrusive = kCP_NoRecrusiveSearch );
}	// namespace CP_UIFieldGetters

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_UIFieldGetters


