//=========================================================================
//
//	FILE:				CP_Events_Defines.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			Definitions for common events handled in CPLAT.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_Events_Defines
#define _H_CP_Events_Defines
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_OSTypes.h"
#include "CP_Types.h"

CPLAT_Begin_Namespace_CPLAT

//=========================================================================
//	Event defines
//=========================================================================
	// Common
	enum
	{
		kCP_EventClassAction = CP_FOUR_CHAR_CODE('CPAC'),
		
		#if TARGET_OS_WIN32
			kCP_Event_UndoAction = WM_USER + 1,
			kCP_Event_RedoAction = WM_USER + 2			
		#else
			kCP_Event_UndoAction = CP_FOUR_CHAR_CODE('UNDO'),
			kCP_Event_RedoAction = CP_FOUR_CHAR_CODE('REDO')
		#endif
	};
	
	// Platform specific
#if TARGET_OS_MAC
	enum
	{
		kCP_EventClassMouse = kEventClassMouse
	};

	enum
	{
		kCP_Event_Draw = kEventControlDraw
	};

	enum
	{
		kCP_Event_MouseDown = kEventMouseDown,
		kCP_Event_MouseUp = kEventMouseUp
	};
#endif

#if TARGET_OS_WIN32
	enum
	{
		kCP_EventClassMouse = kCP_WINDOW_EVENT
	};

	enum
	{
		kCP_Event_Draw = WM_PAINT
	};

	enum
	{
		kCP_Event_MouseDown = WM_LBUTTONDOWN,
		kCP_Event_MouseUp = WM_LBUTTONUP
	};
#endif

#if TARGET_OS_LINUX
	enum
	{
		kCP_EventClassMouse = CP_FOUR_CHAR_CODE('mous')
	};

	enum
	{
		kCP_Event_Draw = 4
	};

	enum
	{
		kCP_Event_MouseDown = 1,
		kCP_Event_MouseUp = 2
	};
#endif

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_Events_Defines

