//=========================================================================
//
//	FILE:				CP_DocumentPolicy_Multi.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			DESCRIBE CLASS HERE
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 190 $
//						Latest Checkout:  $Date: 2005-05-22 23:40:02 -0700 (Sun, 22 May 2005) $
//
//=========================================================================
#ifndef _H_CP_DocumentPolicy_Multi
#define _H_CP_DocumentPolicy_Multi
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

	// CPLAT_Framework
#include "CP_Document_Base.h"
#include "CP_NoCopy.h"
#include "CP_OSTypes.h"


#include "CP_SignalSlot.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	@class	CP_DocumentPolicy_Multi
*	@brief	1 LINE BRIEF DESCRIPTION HERE
*	
*	DETAILED DESCRIPTION BEGINS HERE
*/

class CP_EXPORT CP_DocumentPolicy_Multi : public CP_NoCopy, public CP_SigSlot::CP_SlotObject
{
public:
											// Construction / destruction
										CP_DocumentPolicy_Multi();
	virtual								~CP_DocumentPolicy_Multi() throw();

			void						OnOpenApplication();							

											// Commands
			bool						HandleQuitCommand();
			void						HandleNewUpdateCommandStatusCommand(
												CP_CommandStatus& inOutCommandStatus,
												bool& inOutWasHandled,
												CP_CommandNo& inCommandNo );
			void						HandleNewCommand(
												OSStatus& inOutStatus,
												CP_CommandNo& inCommandNo );
			void						HandleOpenUpdateCommandStatusCommand(
												CP_CommandStatus& inOutCommandStatus,
												bool& inOutWasHandled,
												CP_CommandNo& inCommandNo );
			void						HandleOpenCommand(
												OSStatus& inOutStatus,
												CP_CommandNo& inCommandNo );
			void						HandleSaveCommand(
												OSStatus& inOutStatus,
												CP_CommandNo& inCommandNo );
			void						HandleSaveAsCommand(
												OSStatus& inOutStatus,
												CP_CommandNo& inCommandNo );
			
			void						SetNewDocOnOpenApp( bool inNewDocOnOpenApp )		{ fNewDocOnOpenApp = inNewDocOnOpenApp; };

	//! @name Document Type
	//@{
			FourCharCode				GetDefaultDocumentType()							{ return( fDocType ); }							
			void						SetDefaultDocumentType( FourCharCode inDocType )	{ fDocType = inDocType; }							
	//@}

			
	virtual CP_Document_Base			*CreateNewDocument( FourCharCode inDocType );
	virtual CP_Document_Base			*OpenDocument( const CP_FileSystemSpec& inFileSpec );

	virtual SInt32						CountDocuments();
	virtual	CP_ScriptableObject_Imp		*GetNthDocument( SInt32 inPosition );

private:
			void						NewDocument();

			void						HandleGetFileDialogResult(
												CPLAT::CP_FileSystemDialogs_Base *inSendingDialog,
												const CP_FileSystemSpec& inSelection,
												bool inOverwrite );

	// class data
protected:
	bool								fNewDocOnOpenApp;

	FourCharCode						fDocType;
	
//========================================================================
// Platform specific routines
//========================================================================
#if TARGET_OS_MAC
public:
	//! @name AppleEvents
	//@{
	virtual	void						HandleOpenDocumentAppleEvent(
												const AppleEvent& inEvent,
												AppleEvent& inOutReply );

	virtual	CP_ScriptableObject_Imp 	*DoAE_CreateElement(
												DescType inDesiredClass,
												DescType inInsertLocation,
												const AppleEvent& inEvent,
												AppleEvent& inOutAEReply );
	//@}
#endif

#if TARGET_OS_WIN32
#endif

#if TARGET_OS_LINUX
#endif
};

CPLAT_End_Namespace_CPLAT

#endif	// _H_CP_DocumentPolicy_Multi

