//=========================================================================
//
//	FILE:				CP_View_Imp_GtkScroller.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 162 $
//						Latest Checkout:  $Date: 2005-04-28 15:05:07 -0700 (Thu, 28 Apr 2005) $
//
//=========================================================================
#ifndef _H_CP_View_Imp_GtkScroller
#define _H_CP_View_Imp_GtkScroller
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_LINUX

	// CPLAT_Framework
#include "CP_ScrollBar.h"
#include "CP_SignalSlot.h"
#include "CP_View_Imp_Gtk.h"

CPLAT_Begin_Namespace_CPLAT

class CP_EXPORT CP_View_Imp_GtkScroller : public CP_View_Imp_Gtk, public CP_SigSlot::CP_SlotObject
{
public:
									// Construction / destruction
								CP_View_Imp_GtkScroller(
										CP_View_Imp *inOwnerViewImp,
										CP_View *inSuperview,
										const CP_Point& inUpperLeft,
										const CP_Size& inContentSize );
	virtual						~CP_View_Imp_GtkScroller() throw();

			void				HandleSetScrollingView( CP_ScrollableView *inScrollableView );

	virtual	void				SetPortBounds( const CP_Rect& inBounds );
			void				HandleBoundsChanged(
										const CP_Rect& inPreviousBounds,
										const CP_Rect& inNewBounds );

	virtual	CP_Rect				GetContentBounds();

	//! @name Slots
	//@{
	virtual	void				ImageBoundsChanged( CP_DataValueHolder& inValue );
	//@}

protected:

private:
			void				Init(
										CP_View_Imp *inOwnerViewImp,
										const CP_Point& inUpperLeft,
										const CP_Size& inContentSize );

	// class data
protected:
	CP_ScrollBar				*fHorizontalScrollBar; 
	CP_ScrollBar				*fVerticalScrollBar;
};

CPLAT_End_Namespace_CPLAT

#endif	// TARGET_OS_LINUX

#endif	// _H_CP_View_Imp_GtkScroller

