//=========================================================================
//
//	FILE:				CP_HDC.h
//	
//						Copyright  2004. Ken Stahlman. All Rights Reserved.
//	
//	PURPOSE:			A class to manage a Windows HDC.
//	
//	HISTORY:			1st Version - August 2004.
//	
//	NOTES:				- none -
//
//	VERSION:			Current Revision: $Rev: 2 $
//						Latest Checkout:  $Date: 2004-12-21 19:40:38 -0800 (Tue, 21 Dec 2004) $
//
//=========================================================================
#ifndef _H_CP_HDC
#define _H_CP_HDC
#ifndef TARGET_OS_LINUX
	#pragma once
#endif

#if TARGET_OS_WIN32

	// CPLAT_Framework
#include "CP_M_ReferenceCounted.h"
#include "CP_Types.h"

CPLAT_Begin_Namespace_CPLAT

/*!
*	@class		CP_HDC
*	@brief		Class that provides a wrapper for the Windows HDC.
*
*				This class will provide reference counted management of the
*				Windows HDC resource.
*/
class CP_EXPORT CP_HDC : public CP_M_RefCounted
{
public:
	//! @name Constructor / Destructor
	//@{
	//! Constructor.
										CP_HDC(
												HDC inHDC,
												HWND inHWND );
										CP_HDC( const CP_HDC& inHDC );
	//! Destructor.
	virtual								~CP_HDC() throw();
	//@}
			
	//! @name Getters
	//@{
			HDC							GetHDC()									{ return( fHDC ); }
	//@}

	//! @name operators
	//@{
			CP_HDC&						operator =( const CP_HDC& inHDC );
	//@}

protected:

	// class data
protected:
	HDC									fHDC;		/*! The HDC we manage. */
	HWND								fHWND;
};

CPLAT_End_Namespace_CPLAT

#endif  // TARGET_OS_WIN32

#endif	// _H_CP_HDC

